#include <iostream>
#include <cstdio>

int main()
{
    //std::ios::sync_with_stdio(false);
    int N, Q;
    scanf("%d %d", &N, &Q);
    int A[N+1];
    for(int i=1; i<=N; i++)scanf("%d", &A[i]);
    int L, R, res;
    for(int i=0; i<Q; i++)
    {
        scanf("%d %d", &L, &R);
        res=A[L];
        for(int j=L+1; j<=R; j++) res&=A[j];
        printf("%d\n", res);
    }
    return 0;
}